<template>
  <div style="text-align: center">
    <h1>Vending Machine</h1>

    <VendingMachineIntro/>

    <VendingMachineStock
        :stock="stock"
        :accepted-money="acceptedMoney"
    />

  </div>
</template>

<script>
import API from '@/api';
import VendingMachineStock from './Stock';
import VendingMachineIntro from './Intro';

export default {
  name: 'VendingMachine',
  components: {
    VendingMachineStock,
    VendingMachineIntro,
  },
  data() {
    return {
      isLoading: false,
      stock: [],
      availableChange: [],
      acceptedMoney: [],
    };
  },
  mounted() {
    this.loadMachine();
  },
  methods: {
    async loadMachine() {
      if (this.isLoading) {
        return;
      }

      this.isLoading = true;

      try {
        const data = (await API.loadMachine()).data;
        this.stock = data.stock;
        this.acceptedMoney = data.accepted_money;
        this.availableChange = data.available_change;
      } catch (e) {
        alert('Could not load machine. Please try again.');
      } finally {
        this.isLoading = false;
      }
    },
  },
};
</script>